CVE-2021-3782

NameCVE-2021-3782
DescriptionAn internal reference count is held on the buffer pool, incremented every time a new buffer is created from the pool. The reference count is maintained as an int; on LP64 systems this can cause the reference count to overflow if the client creates a large number of wl_shm buffer objects, or if it can coerce the server to create a large number of external references to the buffer storage. With the reference count overflowing, a use-after-free can be constructed on the wl_shm_pool tracking structure, where values may be incremented or decremented; it may also be possible to construct a limited oracle to leak 4 bytes of server-side memory to the attacking client at a time.
SourceCVE (at NVD; CERT, LWN, oss-sec, fulldisc, bugtraq, EDB, Metasploit, Red Hat, Ubuntu, Gentoo, SUSE bugzilla/CVE, Mageia, GitHub advisories/code/issues, web search, more)

Vulnerable and fixed packages

The table below lists information on source packages.

Source PackageReleaseVersionStatus
wayland (PTS)buster1.16.0-1vulnerable
bullseye1.18.0-2~exp1.1vulnerable
bookworm, sid1.21.0-1fixed

The information below is based on the following data on fixed versions.

PackageTypeReleaseFixed VersionUrgencyOriginDebian Bugs
waylandsource(unstable)1.21.0-1

Notes

[bullseye] - wayland <no-dsa> (Minor issue)
[buster] - wayland <no-dsa> (Minor issue)
https://gitlab.freedesktop.org/wayland/wayland/-/issues/224
https://gitlab.freedesktop.org/wayland/wayland/-/commit/b19488c7154b902354cb26a27f11415d7799b0b2 (1.20.91)

Search for package or bug name: Reporting problems